Index: /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Shared/MatrixJsonItemControl.Designer.cs
===================================================================
--- /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Shared/MatrixJsonItemControl.Designer.cs	(revision 17828)
+++ /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Shared/MatrixJsonItemControl.Designer.cs	(revision 17828)
@@ -0,0 +1,127 @@
+﻿
+namespace HeuristicLab.JsonInterface.OptimizerIntegration {
+  partial class MatrixJsonItemControl {
+    /// <summary> 
+    /// Erforderliche Designervariable.
+    /// </summary>
+    private System.ComponentModel.IContainer components = null;
+
+    /// <summary> 
+    /// Verwendete Ressourcen bereinigen.
+    /// </summary>
+    /// <param name="disposing">True, wenn verwaltete Ressourcen gelöscht werden sollen; andernfalls False.</param>
+    protected override void Dispose(bool disposing) {
+      if (disposing && (components != null)) {
+        components.Dispose();
+      }
+      base.Dispose(disposing);
+    }
+
+    #region Vom Komponenten-Designer generierter Code
+
+    /// <summary> 
+    /// Erforderliche Methode für die Designerunterstützung. 
+    /// Der Inhalt der Methode darf nicht mit dem Code-Editor geändert werden.
+    /// </summary>
+    private void InitializeComponent() {
+      this.tableLayoutPanel1 = new System.Windows.Forms.TableLayoutPanel();
+      this.groupBox2 = new System.Windows.Forms.GroupBox();
+      this.tableLayoutPanel2 = new System.Windows.Forms.TableLayoutPanel();
+      this.checkBoxColumnsResizable = new System.Windows.Forms.CheckBox();
+      this.checkBoxRowsResizable = new System.Windows.Forms.CheckBox();
+      this.tableLayoutPanel1.SuspendLayout();
+      this.groupBox2.SuspendLayout();
+      this.tableLayoutPanel2.SuspendLayout();
+      this.SuspendLayout();
+      // 
+      // tableLayoutPanel1
+      // 
+      this.tableLayoutPanel1.ColumnCount = 1;
+      this.tableLayoutPanel1.ColumnStyles.Add(new System.Windows.Forms.ColumnStyle(System.Windows.Forms.SizeType.Percent, 100F));
+      this.tableLayoutPanel1.Controls.Add(this.groupBox2, 0, 0);
+      this.tableLayoutPanel1.Dock = System.Windows.Forms.DockStyle.Fill;
+      this.tableLayoutPanel1.Location = new System.Drawing.Point(0, 0);
+      this.tableLayoutPanel1.Name = "tableLayoutPanel1";
+      this.tableLayoutPanel1.RowCount = 2;
+      this.tableLayoutPanel1.RowStyles.Add(new System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Absolute, 63F));
+      this.tableLayoutPanel1.RowStyles.Add(new System.Windows.Forms.RowStyle());
+      this.tableLayoutPanel1.Size = new System.Drawing.Size(526, 63);
+      this.tableLayoutPanel1.TabIndex = 24;
+      // 
+      // groupBox2
+      // 
+      this.groupBox2.Controls.Add(this.tableLayoutPanel2);
+      this.groupBox2.Dock = System.Windows.Forms.DockStyle.Fill;
+      this.groupBox2.Location = new System.Drawing.Point(0, 0);
+      this.groupBox2.Margin = new System.Windows.Forms.Padding(0);
+      this.groupBox2.Name = "groupBox2";
+      this.groupBox2.Size = new System.Drawing.Size(526, 63);
+      this.groupBox2.TabIndex = 19;
+      this.groupBox2.TabStop = false;
+      this.groupBox2.Text = "Matrix Properties";
+      // 
+      // tableLayoutPanel2
+      // 
+      this.tableLayoutPanel2.ColumnCount = 1;
+      this.tableLayoutPanel2.ColumnStyles.Add(new System.Windows.Forms.ColumnStyle(System.Windows.Forms.SizeType.Percent, 100F));
+      this.tableLayoutPanel2.ColumnStyles.Add(new System.Windows.Forms.ColumnStyle(System.Windows.Forms.SizeType.Absolute, 20F));
+      this.tableLayoutPanel2.Controls.Add(this.checkBoxRowsResizable, 0, 0);
+      this.tableLayoutPanel2.Controls.Add(this.checkBoxColumnsResizable, 0, 1);
+      this.tableLayoutPanel2.Dock = System.Windows.Forms.DockStyle.Fill;
+      this.tableLayoutPanel2.Location = new System.Drawing.Point(3, 16);
+      this.tableLayoutPanel2.Margin = new System.Windows.Forms.Padding(0);
+      this.tableLayoutPanel2.Name = "tableLayoutPanel2";
+      this.tableLayoutPanel2.RowCount = 2;
+      this.tableLayoutPanel2.RowStyles.Add(new System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Percent, 50F));
+      this.tableLayoutPanel2.RowStyles.Add(new System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Percent, 50F));
+      this.tableLayoutPanel2.Size = new System.Drawing.Size(520, 44);
+      this.tableLayoutPanel2.TabIndex = 22;
+      // 
+      // checkBoxColumnsResizable
+      // 
+      this.checkBoxColumnsResizable.AutoSize = true;
+      this.checkBoxColumnsResizable.Dock = System.Windows.Forms.DockStyle.Fill;
+      this.checkBoxColumnsResizable.Location = new System.Drawing.Point(0, 22);
+      this.checkBoxColumnsResizable.Margin = new System.Windows.Forms.Padding(0);
+      this.checkBoxColumnsResizable.Name = "checkBoxColumnsResizable";
+      this.checkBoxColumnsResizable.Size = new System.Drawing.Size(520, 22);
+      this.checkBoxColumnsResizable.TabIndex = 7;
+      this.checkBoxColumnsResizable.Text = "Columns Resizable";
+      this.checkBoxColumnsResizable.UseVisualStyleBackColor = true;
+      // 
+      // checkBoxRowsResizable
+      // 
+      this.checkBoxRowsResizable.AutoSize = true;
+      this.checkBoxRowsResizable.Dock = System.Windows.Forms.DockStyle.Fill;
+      this.checkBoxRowsResizable.Location = new System.Drawing.Point(0, 0);
+      this.checkBoxRowsResizable.Margin = new System.Windows.Forms.Padding(0);
+      this.checkBoxRowsResizable.Name = "checkBoxRowsResizable";
+      this.checkBoxRowsResizable.Size = new System.Drawing.Size(520, 22);
+      this.checkBoxRowsResizable.TabIndex = 4;
+      this.checkBoxRowsResizable.Text = "Rows Resizable";
+      this.checkBoxRowsResizable.UseVisualStyleBackColor = true;
+      // 
+      // MatrixJsonItemControl
+      // 
+      this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
+      this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
+      this.Controls.Add(this.tableLayoutPanel1);
+      this.Name = "MatrixJsonItemControl";
+      this.Size = new System.Drawing.Size(526, 63);
+      this.tableLayoutPanel1.ResumeLayout(false);
+      this.groupBox2.ResumeLayout(false);
+      this.tableLayoutPanel2.ResumeLayout(false);
+      this.tableLayoutPanel2.PerformLayout();
+      this.ResumeLayout(false);
+
+    }
+
+    #endregion
+
+    private System.Windows.Forms.TableLayoutPanel tableLayoutPanel1;
+    private System.Windows.Forms.GroupBox groupBox2;
+    private System.Windows.Forms.TableLayoutPanel tableLayoutPanel2;
+    private System.Windows.Forms.CheckBox checkBoxRowsResizable;
+    private System.Windows.Forms.CheckBox checkBoxColumnsResizable;
+  }
+}
Index: /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Shared/MatrixJsonItemControl.cs
===================================================================
--- /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Shared/MatrixJsonItemControl.cs	(revision 17828)
+++ /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Shared/MatrixJsonItemControl.cs	(revision 17828)
@@ -0,0 +1,16 @@
+﻿using System.Windows.Forms;
+
+namespace HeuristicLab.JsonInterface.OptimizerIntegration {
+  public partial class MatrixJsonItemControl : UserControl {
+    public MatrixJsonItemControl() {
+      InitializeComponent();
+    }
+
+    public static MatrixJsonItemControl Create(IJsonItemVM vm) {
+      var control = new MatrixJsonItemControl();
+      control.checkBoxRowsResizable.DataBindings.Add("Checked", vm, nameof(IMatrixJsonItemVM.RowsResizable));
+      control.checkBoxColumnsResizable .DataBindings.Add("Checked", vm, nameof(IMatrixJsonItemVM.ColumnsResizable));
+      return control;
+    }
+  }
+}
Index: /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Shared/NumericRangeControl.Designer.cs
===================================================================
--- /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Shared/NumericRangeControl.Designer.cs	(revision 17827)
+++ /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Shared/NumericRangeControl.Designer.cs	(revision 17828)
@@ -26,13 +26,15 @@
       this.components = new System.ComponentModel.Container();
       this.groupBox2 = new System.Windows.Forms.GroupBox();
-      this.checkBoxTo = new System.Windows.Forms.CheckBox();
+      this.tableLayoutPanel2 = new System.Windows.Forms.TableLayoutPanel();
       this.textBoxTo = new System.Windows.Forms.TextBox();
-      this.errorProvider = new System.Windows.Forms.ErrorProvider(this.components);
       this.textBoxFrom = new System.Windows.Forms.TextBox();
       this.checkBoxFrom = new System.Windows.Forms.CheckBox();
-      this.tableLayoutPanel2 = new System.Windows.Forms.TableLayoutPanel();
+      this.checkBoxTo = new System.Windows.Forms.CheckBox();
+      this.errorProvider = new System.Windows.Forms.ErrorProvider(this.components);
+      this.tableLayoutPanel1 = new System.Windows.Forms.TableLayoutPanel();
       this.groupBox2.SuspendLayout();
+      this.tableLayoutPanel2.SuspendLayout();
       ((System.ComponentModel.ISupportInitialize)(this.errorProvider)).BeginInit();
-      this.tableLayoutPanel2.SuspendLayout();
+      this.tableLayoutPanel1.SuspendLayout();
       this.SuspendLayout();
       // 
@@ -49,15 +51,23 @@
       this.groupBox2.Text = "Range";
       // 
-      // checkBoxTo
+      // tableLayoutPanel2
       // 
-      this.checkBoxTo.AutoSize = true;
-      this.checkBoxTo.Dock = System.Windows.Forms.DockStyle.Fill;
-      this.checkBoxTo.Location = new System.Drawing.Point(0, 22);
-      this.checkBoxTo.Margin = new System.Windows.Forms.Padding(0);
-      this.checkBoxTo.Name = "checkBoxTo";
-      this.checkBoxTo.Size = new System.Drawing.Size(100, 22);
-      this.checkBoxTo.TabIndex = 7;
-      this.checkBoxTo.Text = "To:";
-      this.checkBoxTo.UseVisualStyleBackColor = true;
+      this.tableLayoutPanel2.ColumnCount = 2;
+      this.tableLayoutPanel2.ColumnStyles.Add(new System.Windows.Forms.ColumnStyle(System.Windows.Forms.SizeType.Absolute, 100F));
+      this.tableLayoutPanel2.ColumnStyles.Add(new System.Windows.Forms.ColumnStyle(System.Windows.Forms.SizeType.Percent, 100F));
+      this.tableLayoutPanel2.Controls.Add(this.textBoxTo, 1, 1);
+      this.tableLayoutPanel2.Controls.Add(this.textBoxFrom, 1, 0);
+      this.tableLayoutPanel2.Controls.Add(this.checkBoxFrom, 0, 0);
+      this.tableLayoutPanel2.Controls.Add(this.checkBoxTo, 0, 1);
+      this.tableLayoutPanel2.Dock = System.Windows.Forms.DockStyle.Fill;
+      this.tableLayoutPanel2.Location = new System.Drawing.Point(3, 16);
+      this.tableLayoutPanel2.Margin = new System.Windows.Forms.Padding(0);
+      this.tableLayoutPanel2.Name = "tableLayoutPanel2";
+      this.tableLayoutPanel2.RowCount = 2;
+      this.tableLayoutPanel2.RowStyles.Add(new System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Percent, 50F));
+      this.tableLayoutPanel2.RowStyles.Add(new System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Percent, 50F));
+      this.tableLayoutPanel2.RowStyles.Add(new System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Absolute, 20F));
+      this.tableLayoutPanel2.Size = new System.Drawing.Size(520, 44);
+      this.tableLayoutPanel2.TabIndex = 22;
       // 
       // textBoxTo
@@ -72,9 +82,4 @@
       this.textBoxTo.TabIndex = 6;
       this.textBoxTo.Validating += new System.ComponentModel.CancelEventHandler(this.textBoxTo_Validating);
-      // 
-      // errorProvider
-      // 
-      this.errorProvider.BlinkStyle = System.Windows.Forms.ErrorBlinkStyle.NeverBlink;
-      this.errorProvider.ContainerControl = this;
       // 
       // textBoxFrom
@@ -102,22 +107,34 @@
       this.checkBoxFrom.UseVisualStyleBackColor = true;
       // 
-      // tableLayoutPanel2
+      // checkBoxTo
       // 
-      this.tableLayoutPanel2.ColumnCount = 2;
-      this.tableLayoutPanel2.ColumnStyles.Add(new System.Windows.Forms.ColumnStyle(System.Windows.Forms.SizeType.Absolute, 100F));
-      this.tableLayoutPanel2.ColumnStyles.Add(new System.Windows.Forms.ColumnStyle(System.Windows.Forms.SizeType.Percent, 100F));
-      this.tableLayoutPanel2.Controls.Add(this.textBoxTo, 1, 1);
-      this.tableLayoutPanel2.Controls.Add(this.textBoxFrom, 1, 0);
-      this.tableLayoutPanel2.Controls.Add(this.checkBoxFrom, 0, 0);
-      this.tableLayoutPanel2.Controls.Add(this.checkBoxTo, 0, 1);
-      this.tableLayoutPanel2.Dock = System.Windows.Forms.DockStyle.Fill;
-      this.tableLayoutPanel2.Location = new System.Drawing.Point(3, 16);
-      this.tableLayoutPanel2.Margin = new System.Windows.Forms.Padding(0);
-      this.tableLayoutPanel2.Name = "tableLayoutPanel2";
-      this.tableLayoutPanel2.RowCount = 2;
-      this.tableLayoutPanel2.RowStyles.Add(new System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Percent, 50F));
-      this.tableLayoutPanel2.RowStyles.Add(new System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Percent, 50F));
-      this.tableLayoutPanel2.Size = new System.Drawing.Size(520, 44);
-      this.tableLayoutPanel2.TabIndex = 22;
+      this.checkBoxTo.AutoSize = true;
+      this.checkBoxTo.Dock = System.Windows.Forms.DockStyle.Fill;
+      this.checkBoxTo.Location = new System.Drawing.Point(0, 22);
+      this.checkBoxTo.Margin = new System.Windows.Forms.Padding(0);
+      this.checkBoxTo.Name = "checkBoxTo";
+      this.checkBoxTo.Size = new System.Drawing.Size(100, 22);
+      this.checkBoxTo.TabIndex = 7;
+      this.checkBoxTo.Text = "To:";
+      this.checkBoxTo.UseVisualStyleBackColor = true;
+      // 
+      // errorProvider
+      // 
+      this.errorProvider.BlinkStyle = System.Windows.Forms.ErrorBlinkStyle.NeverBlink;
+      this.errorProvider.ContainerControl = this;
+      // 
+      // tableLayoutPanel1
+      // 
+      this.tableLayoutPanel1.ColumnCount = 1;
+      this.tableLayoutPanel1.ColumnStyles.Add(new System.Windows.Forms.ColumnStyle(System.Windows.Forms.SizeType.Percent, 100F));
+      this.tableLayoutPanel1.Controls.Add(this.groupBox2, 0, 0);
+      this.tableLayoutPanel1.Dock = System.Windows.Forms.DockStyle.Fill;
+      this.tableLayoutPanel1.Location = new System.Drawing.Point(0, 0);
+      this.tableLayoutPanel1.Name = "tableLayoutPanel1";
+      this.tableLayoutPanel1.RowCount = 2;
+      this.tableLayoutPanel1.RowStyles.Add(new System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Absolute, 63F));
+      this.tableLayoutPanel1.RowStyles.Add(new System.Windows.Forms.RowStyle());
+      this.tableLayoutPanel1.Size = new System.Drawing.Size(526, 63);
+      this.tableLayoutPanel1.TabIndex = 23;
       // 
       // NumericRangeControl
@@ -125,11 +142,12 @@
       this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
       this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
-      this.Controls.Add(this.groupBox2);
+      this.Controls.Add(this.tableLayoutPanel1);
       this.Name = "NumericRangeControl";
       this.Size = new System.Drawing.Size(526, 63);
       this.groupBox2.ResumeLayout(false);
-      ((System.ComponentModel.ISupportInitialize)(this.errorProvider)).EndInit();
       this.tableLayoutPanel2.ResumeLayout(false);
       this.tableLayoutPanel2.PerformLayout();
+      ((System.ComponentModel.ISupportInitialize)(this.errorProvider)).EndInit();
+      this.tableLayoutPanel1.ResumeLayout(false);
       this.ResumeLayout(false);
 
@@ -144,4 +162,5 @@
     private System.Windows.Forms.TextBox textBoxFrom;
     private System.Windows.Forms.TableLayoutPanel tableLayoutPanel2;
+    private System.Windows.Forms.TableLayoutPanel tableLayoutPanel1;
   }
 }
Index: /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Shared/NumericRangeControl.cs
===================================================================
--- /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Shared/NumericRangeControl.cs	(revision 17827)
+++ /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Shared/NumericRangeControl.cs	(revision 17828)
@@ -51,4 +51,15 @@
       }
     }
+
+    public static UserControl Create(IJsonItemVM vm) {
+      NumericRangeControl numericRangeControl = new NumericRangeControl();
+      numericRangeControl.TBMinRange.DataBindings.Add("Text", vm, nameof(RangedValueBaseVM<int, IntJsonItem>.MinRange));
+      numericRangeControl.TBMaxRange.DataBindings.Add("Text", vm, nameof(RangedValueBaseVM<int, IntJsonItem>.MaxRange));
+      numericRangeControl.EnableMinRange.DataBindings.Add("Checked", vm, nameof(RangedValueBaseVM<int, IntJsonItem>.EnableMinRange),
+        false, DataSourceUpdateMode.OnPropertyChanged);
+      numericRangeControl.EnableMaxRange.DataBindings.Add("Checked", vm, nameof(RangedValueBaseVM<int, IntJsonItem>.EnableMaxRange),
+        false, DataSourceUpdateMode.OnPropertyChanged);
+      return numericRangeControl;
+    }
   }
 }
Index: /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/ViewModels/ArrayValueVM.cs
===================================================================
--- /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/ViewModels/ArrayValueVM.cs	(revision 17827)
+++ /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/ViewModels/ArrayValueVM.cs	(revision 17828)
@@ -9,34 +9,10 @@
 namespace HeuristicLab.JsonInterface.OptimizerIntegration {
 
-  
-
-
-
-  /*
-  public class StringArrayValueVM : ArrayValueVM<int, IntArrayJsonItem> {
-    public override Type TargetedJsonItemType => typeof(StringArrayJsonItem);
-
-    protected override int MinTypeValue => int.MinValue;
-
-    protected override int MaxTypeValue => int.MaxValue;
-
-    public override UserControl Control =>
-      new JsonItemBaseControl(this, new JsonItemIntArrayValueControl(this));
-
-    public override int[] Value {
-      get => Item.Value;
-      set {
-        Item.Value = value;
-        OnPropertyChange(this, nameof(Value));
-      }
-    }
-  }
-  */
-
-
   public abstract class ArrayValueVM<T, JsonItemType> : RangedValueBaseVM<T, JsonItemType>, IArrayJsonItemVM
     where T : IComparable
     where JsonItemType : class, IArrayJsonItem, IIntervalRestrictedJsonItem<T> {
-    
+
+    public override UserControl Control => CompoundControl.Create(base.Control, ArrayJsonItemControl.Create(this));
+
     public ArrayValueVM() { }
     
Index: /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/ViewModels/ConcreteRestrictedJsonItemVM.cs
===================================================================
--- /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/ViewModels/ConcreteRestrictedJsonItemVM.cs	(revision 17828)
+++ /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/ViewModels/ConcreteRestrictedJsonItemVM.cs	(revision 17828)
@@ -0,0 +1,79 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using System.Threading.Tasks;
+using System.Windows.Forms;
+
+namespace HeuristicLab.JsonInterface.OptimizerIntegration {
+  /// <summary>
+  /// Abstract VM class for concreted restricted JsonItems
+  /// </summary>
+  /// <typeparam name="T">JsonItemType</typeparam>
+  /// <typeparam name="X">Type of the range array (ConcreteRestrictedItemArray)</typeparam>
+  /// <typeparam name="V">Type of the value property</typeparam>
+  public abstract class ConcreteRestrictedJsonItemVM<T, X, V> : JsonItemVMBase<T>
+    where T : class, IConcreteRestrictedJsonItem<X>, IValueJsonItem<V> {
+    public override UserControl Control {
+      get {
+        var control = new ConcreteItemsRestrictor();
+        control.Init(Item.ConcreteRestrictedItems);
+        control.OnChecked += AddComboOption;
+        control.OnUnchecked += RemoveComboOption;
+        return control;
+      }
+    }
+
+    public V Value {
+      get => Item.Value;
+      set {
+        Item.Value = value;
+        OnPropertyChange(this, nameof(Value));
+      }
+    }
+
+    public IEnumerable<X> Range {
+      get => Item.ConcreteRestrictedItems;
+      set {
+        Item.ConcreteRestrictedItems = value;
+        //check if value is still in range
+
+        if (!RangeContainsValue()) {
+          Value = GetDefaultValue();
+
+          //if no elements exists -> deselect item
+          if (Range.Count() == 0)
+            base.Selected = false;
+
+          OnPropertyChange(this, nameof(Value));
+        }
+
+        OnPropertyChange(this, nameof(Range));
+      }
+    }
+
+    /// <summary>
+    /// Method to check if the value exists in the allowed range array.
+    /// </summary>
+    /// <returns></returns>
+    protected abstract bool RangeContainsValue();
+
+    /// <summary>
+    /// Method to get or generate a default value for property "Value".
+    /// </summary>
+    /// <returns></returns>
+    protected abstract V GetDefaultValue();
+
+    private void AddComboOption(object opt) {
+      var items = new List<X>(Range);
+      items.Add((X)opt);
+      Range = items;
+    }
+
+    private void RemoveComboOption(object opt) {
+      var items = new List<X>(Range);
+      items.Remove((X)opt);
+      Range = items;
+    }
+  }
+}
Index: /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/ViewModels/DoubleVMs.cs
===================================================================
--- /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/ViewModels/DoubleVMs.cs	(revision 17827)
+++ /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/ViewModels/DoubleVMs.cs	(revision 17828)
@@ -8,22 +8,11 @@
 namespace HeuristicLab.JsonInterface.OptimizerIntegration {
   public class DoubleRangeVM : RangeVM<double, DoubleRangeJsonItem> {
-
     protected override double MinTypeValue => double.MinValue;
-
     protected override double MaxTypeValue => double.MaxValue;
-
-    public override UserControl Control =>
-      new JsonItemRangeControl(this);
   }
 
   public class DoubleArrayValueVM : ArrayValueVM<double, DoubleArrayJsonItem> {
-
     protected override double MinTypeValue => double.MinValue;
-
     protected override double MaxTypeValue => double.MaxValue;
-
-    public override UserControl Control =>
-      new JsonItemDoubleArrayValueControl(this);
-
     public override double[] Value {
       get => Item.Value;
@@ -36,7 +25,4 @@
 
   public class DoubleMatrixValueVM : MatrixValueVM<double, DoubleMatrixJsonItem> {
-    public override UserControl Control =>
-      new JsonItemDoubleMatrixValueControl(this);
-
     public override double[][] Value {
       get => Item.Value;
@@ -46,17 +32,11 @@
       }
     }
-
     protected override double MinTypeValue => double.MinValue;
-
     protected override double MaxTypeValue => double.MaxValue;
   }
 
   public class DoubleValueVM : SingleValueVM<double, DoubleJsonItem> {
-
     protected override double MinTypeValue => double.MinValue;
     protected override double MaxTypeValue => double.MaxValue;
-
-    public override UserControl Control =>
-       new JsonItemDoubleValueControl(this);
   }
 }
Index: /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/ViewModels/IntVMs.cs
===================================================================
--- /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/ViewModels/IntVMs.cs	(revision 17827)
+++ /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/ViewModels/IntVMs.cs	(revision 17828)
@@ -8,11 +8,6 @@
 namespace HeuristicLab.JsonInterface.OptimizerIntegration {
   public class IntArrayValueVM : ArrayValueVM<int, IntArrayJsonItem> {
-
     protected override int MinTypeValue => int.MinValue;
-
     protected override int MaxTypeValue => int.MaxValue;
-
-    public override UserControl Control =>
-      new JsonItemBaseControl(this, new JsonItemIntArrayValueControl(this));
 
     public override int[] Value {
@@ -26,20 +21,11 @@
 
   public class IntRangeVM : RangeVM<int, IntRangeJsonItem> {
-
     protected override int MinTypeValue => int.MinValue;
-
     protected override int MaxTypeValue => int.MaxValue;
-
-    public override UserControl Control =>
-      new JsonItemRangeControl(this);
   }
 
   public class IntValueVM : SingleValueVM<int, IntJsonItem> {
-
     protected override int MinTypeValue => int.MinValue;
     protected override int MaxTypeValue => int.MaxValue;
-
-    public override UserControl Control =>
-      new JsonItemIntValueControl(this);
   }
 
Index: /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/ViewModels/JsonItemVMBase.cs
===================================================================
--- /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/ViewModels/JsonItemVMBase.cs	(revision 17827)
+++ /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/ViewModels/JsonItemVMBase.cs	(revision 17828)
@@ -9,5 +9,5 @@
 
 namespace HeuristicLab.JsonInterface.OptimizerIntegration {
-  public abstract class JsonItemVMBase<JsonItemType> : IJsonItemVM<JsonItemType> //TODO: RENAME, oder vlt JsonItems direkt als VM?
+  public abstract class JsonItemVMBase<JsonItemType> : IJsonItemVM<JsonItemType>
     where JsonItemType : class, IJsonItem 
   {
Index: /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/ViewModels/LookupJsonItemVM.cs
===================================================================
--- /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/ViewModels/LookupJsonItemVM.cs	(revision 17827)
+++ /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/ViewModels/LookupJsonItemVM.cs	(revision 17828)
@@ -8,7 +8,5 @@
 namespace HeuristicLab.JsonInterface.OptimizerIntegration {
   public class LookupJsonItemVM : JsonItemVMBase<LookupJsonItem>, ILookupJsonItemVM {
-
-    public override UserControl Control => new LookupJsonItemControl(this);
-
+    public override UserControl Control => null;
     public string ActualName {
       get => Item.ActualName;
Index: /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/ViewModels/MatrixValueVM.cs
===================================================================
--- /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/ViewModels/MatrixValueVM.cs	(revision 17827)
+++ /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/ViewModels/MatrixValueVM.cs	(revision 17828)
@@ -13,4 +13,7 @@
     where T : IComparable
     where JsonItemType : class, IMatrixJsonItem, IIntervalRestrictedJsonItem<T> {
+
+    public override UserControl Control => CompoundControl.Create(base.Control, MatrixJsonItemControl.Create(this));
+
     public abstract T[][] Value { get; set; }
     public bool RowsResizable {
Index: /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/ViewModels/RangedValueBaseVM.cs
===================================================================
--- /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/ViewModels/RangedValueBaseVM.cs	(revision 17827)
+++ /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/ViewModels/RangedValueBaseVM.cs	(revision 17828)
@@ -4,4 +4,5 @@
 using System.Text;
 using System.Threading.Tasks;
+using System.Windows.Forms;
 
 namespace HeuristicLab.JsonInterface.OptimizerIntegration {
@@ -11,4 +12,6 @@
     where JsonItemType : class, IIntervalRestrictedJsonItem<T> 
   {
+    public override UserControl Control => NumericRangeControl.Create(this);
+
     public T MinRange {
       get => Item.Minimum;
Index: /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/ViewModels/SingleValueVM.cs
===================================================================
--- /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/ViewModels/SingleValueVM.cs	(revision 17827)
+++ /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/ViewModels/SingleValueVM.cs	(revision 17828)
@@ -19,6 +19,5 @@
     }
     
-    public override UserControl Control =>
-       new JsonItemBoolControl(this);
+    public override UserControl Control => null;
   }
 
Index: /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/ViewModels/StringValueVM.cs
===================================================================
--- /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/ViewModels/StringValueVM.cs	(revision 17827)
+++ /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/ViewModels/StringValueVM.cs	(revision 17828)
@@ -1,60 +1,16 @@
-﻿using System;
-using System.Collections.Generic;
-using System.Linq;
-using System.Text;
-using System.Threading;
-using System.Threading.Tasks;
-using System.Windows.Forms;
+﻿using System.Linq;
 
 namespace HeuristicLab.JsonInterface.OptimizerIntegration {
-  public class StringValueVM : JsonItemVMBase<StringJsonItem> {
-    public override UserControl Control =>
-       new JsonItemValidValuesControl(this);
 
-    public string Value {
-      get => Item.Value?.ToString();
-      set {
-        Item.Value = value;
-        OnPropertyChange(this, nameof(Value));
-      }
-    }
+  public class StringValueVM : ConcreteRestrictedJsonItemVM<StringJsonItem, string, string> {
+    protected override string GetDefaultValue() => Range.FirstOrDefault();
 
-    public IEnumerable<string> Range {
-      get => Item.ConcreteRestrictedItems;
-      set {
-        Item.ConcreteRestrictedItems = value;
-        //check if value is still in range
-        if (!Range.Contains(Value)) {
-          Value = Range.FirstOrDefault();
-          if (Range.Count() == 0)
-            //if no elements exists -> deselect item
-            base.Selected = false;
-          OnPropertyChange(this, nameof(Value));
-        }
-        
-        OnPropertyChange(this, nameof(Range));
-      }
-    }
+    protected override bool RangeContainsValue() => Range.Contains(Value);
   }
 
-  public class StringArrayVM : JsonItemVMBase<StringArrayJsonItem> {
-    public override UserControl Control =>
-       new JsonItemConcreteItemArrayControl(this);
+  public class StringArrayVM : ConcreteRestrictedJsonItemVM<StringArrayJsonItem, string, string[]> {
+    protected override string[] GetDefaultValue() => Range.ToArray();
 
-    public string[] Value {
-      get => Item.Value;
-      set {
-        Item.Value = value;
-        OnPropertyChange(this, nameof(Value));
-      }
-    }
-
-    public IEnumerable<string> Range {
-      get => Item.ConcreteRestrictedItems;
-      set {
-        Item.ConcreteRestrictedItems = value;
-        OnPropertyChange(this, nameof(Range));
-      }
-    }
+    protected override bool RangeContainsValue() => Value.All(x => Range.Any(y => x == y));
   }
 }
